找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 1241|回复: 0

[分享] Read and parse .csv or .txt file

[复制链接]

已领礼包: 859个

财富等级: 财运亨通

发表于 2014-6-7 03:28:59 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×
       [CommandMethod("ptsRead")]
        public void testReadCSV()
        {   // file name contains separated text
            string filePath = @"C:\Test\points.txt";
            if (!File.Exists(filePath))
            {
                MessageBox.Show("File does not exist");
                return;
            }
            // put appropriate delimiter here
            string sep = ";";
            Point3dCollection pts = new Point3dCollection();
            using (System.IO.StreamReader reader = new System.IO.StreamReader(filePath))
            {
                while (!reader.EndOfStream)
                {
                    // Call reader.ReadLine() appropriately
                    string textLine = reader.ReadLine();
                    Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument.Editor.WriteMessage("\n{0}", textLine);
                    string[] tmp = textLine.Split(new string[] { sep }, StringSplitOptions.RemoveEmptyEntries);
                    if (tmp.Length != 0)
                    {
                        Point3d pt = new Point3d(Convert.ToDouble(tmp[0]), Convert.ToDouble(tmp[1]), Convert.ToDouble(tmp[2]));
                        pts.Add(pt);
                    }
                }
            }

            if (pts == null)
            {
                MessageBox.Show("Cant parse this file");
                return;
            }
            Document doc = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument;

            Database db = doc.Database;

            Editor ed = doc.Editor;

            Autodesk.AutoCAD.ApplicationServices.Application.SetSystemVariable("pdmode", 34);

            Autodesk.AutoCAD.ApplicationServices.Application.SetSystemVariable("pdsize", 2.0);

            using (Transaction tr = db.TransactionManager.StartTransaction())
            {
                BlockTableRecord btr = tr.GetObject(db.CurrentSpaceId, OpenMode.ForWrite) as BlockTableRecord;

                foreach (Point3d pnt in pts)
                {
                    DBPoint pt = new DBPoint(pnt);

                    pt.SetDatabaseDefaults();

                    pt.ColorIndex = 1;// <-- set any color of point

                    btr.AppendEntity(pt);

                    DBText txt = new DBText();

                    tr.AddNewlyCreatedDBObject(pt, true);

                    txt.SetDatabaseDefaults();

                    txt.Position = pt.Position;

                    txt.TextString = txt.Position.ToString();//<-- add any textstring to suit

                    txt.Justify = AttachmentPoint.BaseLeft;

                    // txt.AlignmentPoint = pt.Position;

                    txt.AdjustAlignment(db);

                    btr.AppendEntity(txt);

                    tr.AddNewlyCreatedDBObject(txt, true);
                }
                tr.Commit();
            }
        }
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-5-22 13:30 , Processed in 0.314526 second(s), 27 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表